/*
 * Copyright (C) 1996,1997 Michael R. Elkins <me@cs.hmc.edu>
 * 
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 * 
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */ 

#include "muttlib.h"
#include <stdlib.h>
#include <signal.h>

/*
 * This is pretty ugly, but I don't know of any way to detect this other than
 * by experience with these systems.
 */
#if defined(__linux__) || defined(SCO)
#define POSIX_SYSTEM
#endif

int mutt_system (const char *s)
{
  int rc;
#ifndef POSIX_SYSTEM
  struct sigaction act;
  struct sigaction oldint;
  struct sigaction oldchld;
#endif

#ifndef POSIX_SYSTEM
  act.sa_handler = SIG_IGN;
  /* must ignore SIGINT and SIGCHLD (POSIX.1 compliance) */
  sigaction (SIGINT, &act, &oldint);
  sigaction (SIGCHLD, &act, &oldchld);
#endif

  rc = system (s);

#ifndef POSIX_SYSTEM
  /* reset SIGINT and SIGCHLD */
  sigaction (SIGINT, &oldint, NULL);
  sigaction (SIGCHLD, &oldchld, NULL);
#endif

  return (rc);
}
